module counter( out, u, clk, clr, en);

input						u, clk, clr, en;
output[3:0]	out;
reg[3:0]				out;

always @(posedge clk or negedge clr)
begin
	if (clr == 0)
		out = 4'b0000;
	else if(clk && en && u)
		out = out + 1;
	else if(clk && en && ~u)
		out = out - 1;
end

endmodule