module ALU( out, co, s, a, b, selecta, ci);

	output[7:0]	out;
	output						co;
	input[7:0]		a, b;
	input[1:0]		s;
	input							selecta,	ci;
	wire[7:0]			pa, pb, nb;
	wire							w1,w2;

	//Process a
	and ( pa[0], selecta, a[0]);
	and ( pa[1], selecta, a[1]);
	and ( pa[2], selecta, a[2]);
	and ( pa[3], selecta, a[3]);
	and ( pa[4], selecta, a[4]);
	and ( pa[5], selecta, a[5]);
	and ( pa[6], selecta, a[6]);
	and ( pa[7], selecta, a[7]);

	//Process b
	nand ( nb[0], b[0], b[0]);
	nand ( nb[1], b[1], b[1]);
	nand ( nb[2], b[2], b[2]);
	nand ( nb[3], b[3], b[3]);
	nand ( nb[4], b[4], b[4]);
	nand ( nb[5], b[5], b[5]);
	nand ( nb[6], b[6], b[6]);
	nand ( nb[7], b[7], b[7]);
	
	MUX_4_to_1_8 mux ( pb, s, b, nb, 8'b0000_0000, 8'b1111_1111);

	//Adder
	FA8 fa ( out, co, pa, pb, ci);
	
endmodule